//=============================================================================
// ScopeCamTrigger for UT.  By Dawn Knight version 1.04 09/12/2004
//
// Special trigger for DM-DawnsDeepSpace.unr.
// Spawns a DawnsScopeCam, and gives it to a TournamentPlayer.
//=============================================================================
class ScopeCamTrigger extends Triggers;

var() sound TriggerSound; // for TriggerSound Effect.
var   ScopeCam CamLoc; // Decoration located at Spawn point for DawnsScopeCam.
var   float LastTouchTime;
var() float ReTouchDelay;
var   bool bAllowUnTouch;

simulated function PostBeginPlay()
{
	local ScopeCam SC;

	Super.PostBeginPlay();
	if( event != '' )
	{
		// Find the matching ScopeCam
		foreach AllActors( class 'ScopeCam', SC, Event )
		{
			CamLoc = SC;
			break;
		}
	}
	if( CamLoc == none )
	{
		Log("**** No Event->Tag match for ScopeCam!");
		self.Destroy();
	}
}

// Called when something touches the trigger.
singular function Touch( actor Other )
{
	local DawnsScopeCam DSC;

	if( TournamentPlayer( Other ) == none )
		return;
	bAllowUnTouch = true;
	if( Level.TimeSeconds - LastTouchTime < ReTouchDelay )
	{
		bAllowUnTouch = false;
		return;
	}
	LastTouchTime = Level.TimeSeconds;
	foreach AllActors( class'DawnsScopeCam', DSC )
		if( DSC.Owner == Other )
			return;
	DSC = Spawn(class'DawnsScopeCam',TournamentPlayer( Other ),,CamLoc.Location,CamLoc.Rotation );
	DSC.SCT = self;
}

singular function UnTouch( actor Other )
{
	local DawnsScopeCam DSC;

	if( TournamentPlayer( Other ) == none || !bAllowUnTouch )
		return;
	foreach AllActors(class'DawnsScopeCam', DSC )
	{
		if( DSC.Owner == Other )
			DSC.SetOwner( none );
	}
}

defaultproperties
{
     CollisionRadius=8.000000
     CollisionHeight=20.000000
     ReTouchDelay=1.20000
}
